Index: browser/base/content/browser.js
===================================================================
RCS file: /cvsroot/mozilla/browser/base/content/browser.js,v
retrieving revision 1.783
diff -p -U 8 -r1.783 browser.js
--- browser/base/content/browser.js	13 May 2007 15:47:05 -0000	1.783
+++ browser/base/content/browser.js	14 May 2007 09:20:59 -0000
@@ -778,16 +778,19 @@ function BrowserStartup()
   var uriToLoad = null;
   // Check for window.arguments[0]. If present, use that for uriToLoad.
   if ("arguments" in window && window.arguments[0])
     uriToLoad = window.arguments[0];
 
   gIsLoadingBlank = uriToLoad == "about:blank";
 
   prepareForStartup();
+  
+  if (uriToLoad && window.arguments.length >= 6 && window.arguments[5].cookieContainer)
+    getBrowser().docShell.QueryInterface(Components.interfaces.nsICookieCollector).cookieContainer = window.arguments[5].cookieContainer;
 
 #ifdef ENABLE_PAGE_CYCLER
   appCore.startPageCycler();
 #else
 # only load url passed in when we're not page cycling
   if (uriToLoad && !gIsLoadingBlank) {
     if (window.arguments.length >= 3)
       loadURI(uriToLoad, window.arguments[2], window.arguments[3] || null,
@@ -1845,17 +1848,17 @@ function openLocation()
 function openLocationCallback()
 {
   // make sure the DOM is ready
   setTimeout(function() { this.openLocation(); }, 0);
 }
 
 function BrowserOpenTab()
 {
-  gBrowser.loadOneTab("about:blank", null, null, null, false, false);
+  gBrowser.loadOneTab("about:blank", null, null, null, false, false, null);
   if (gURLBar)
     setTimeout(function() { gURLBar.focus(); }, 0);
 }
 
 /* Called from the openLocation dialog. This allows that dialog to instruct
    its opener to open a new window and then step completely out of the way.
    Anything less byzantine is causing horrible crashes, rather believably,
    though oddly only on Linux. */
@@ -1868,17 +1871,17 @@ function delayedOpenWindow(chrome, flags
   // window.arguments[1] be an integer instead of null.
   setTimeout(function() { openDialog(chrome, "_blank", flags, href, null, null, postData); }, 10);
 }
 
 /* Required because the tab needs time to set up its content viewers and get the load of
    the URI kicked off before becoming the active content area. */
 function delayedOpenTab(aUrl, aReferrer, aCharset, aPostData, aAllowThirdPartyFixup)
 {
-  gBrowser.loadOneTab(aUrl, aReferrer, aCharset, aPostData, false, aAllowThirdPartyFixup);
+  gBrowser.loadOneTab(aUrl, aReferrer, aCharset, aPostData, false, aAllowThirdPartyFixup, null);
 }
 
 function BrowserOpenFileWindow()
 {
   // Get filepicker component.
   try {
     const nsIFilePicker = Components.interfaces.nsIFilePicker;
     var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
@@ -1979,17 +1982,18 @@ function BrowserLoadURL(aTriggeringEvent
                true /* allow third party fixup */, aPostData);
     return;
   }
 
   if (aTriggeringEvent && aTriggeringEvent.altKey) {
     handleURLBarRevert();
     content.focus();
     gBrowser.loadOneTab(url, null, null, aPostData, false,
-                        true /* allow third party fixup */);
+                        true, /* allow third party fixup */
+                        null);
     aTriggeringEvent.preventDefault();
     aTriggeringEvent.stopPropagation();
   }
   else
     loadURI(url, null, aPostData, true /* allow third party fixup */);
 
   focusElement(content);
 }
@@ -3143,17 +3147,17 @@ const BrowserSearch = {
     // with a text/html response type.  This is unlikely (since
     // SearchService._addEngineToStore() should fail for such an engine),
     // but let's be on the safe side.
     if (!submission)
       return;
   
     if (useNewTab) {
       getBrowser().loadOneTab(submission.uri.spec, null, null,
-                              submission.postData, null, false);
+                              submission.postData, null, false, null);
     } else
       loadURI(submission.uri.spec, null, submission.postData, false);
   },
 
   /**
    * Returns the search bar element if it is present in the toolbar and not
    * hidden, null otherwise.
    */
@@ -4123,17 +4127,17 @@ nsBrowserAccess.prototype =
     }
     var url = aURI ? aURI.spec : "about:blank";
     switch(aWhere) {
       case Ci.nsIBrowserDOMWindow.OPEN_NEWWINDOW :
         newWindow = openDialog(getBrowserURL(), "_blank", "all,dialog=no", url);
         break;
       case Ci.nsIBrowserDOMWindow.OPEN_NEWTAB :
         var loadInBackground = gPrefService.getBoolPref("browser.tabs.loadDivertedInBackground");
-        var newTab = gBrowser.loadOneTab("about:blank", null, null, null, loadInBackground, false);
+        var newTab = gBrowser.loadOneTab("about:blank", null, null, null, loadInBackground, false, null);
         newWindow = gBrowser.getBrowserForTab(newTab).docShell
                             .QueryInterface(Ci.nsIInterfaceRequestor)
                             .getInterface(Ci.nsIDOMWindow);
         try {
           if (aOpener) {
             location = aOpener.location;
             referrer =
                     Components.classes["@mozilla.org/network/io-service;1"]
Index: browser/base/content/utilityOverlay.js
===================================================================
RCS file: /cvsroot/mozilla/browser/base/content/utilityOverlay.js,v
retrieving revision 1.50
diff -p -U 8 -r1.50 utilityOverlay.js
--- browser/base/content/utilityOverlay.js	7 Mar 2007 20:09:19 -0000	1.50
+++ browser/base/content/utilityOverlay.js	14 May 2007 09:21:00 -0000
@@ -219,17 +219,17 @@ function openUILinkIn( url, where, allow
     w.loadURI(url, referrerUrl, postData, allowThirdPartyFixup);
     break;
   case "tabshifted":
     loadInBackground = !loadInBackground;
     // fall through
   case "tab":
     var browser = w.getBrowser();
     browser.loadOneTab(url, referrerUrl, null, postData, loadInBackground,
-                       allowThirdPartyFixup || false);
+                       allowThirdPartyFixup || false, null);
     break;
   }
 
   // Call focusElement(w.content) instead of w.content.focus() to make sure
   // that we don't raise the old window, since the URI we just loaded may have
   // resulted in a new frontmost window (e.g. "javascript:window.open('');").
   focusElement(w.content);
 }
@@ -551,18 +551,24 @@ function openNewTabWith(aURL, aDocument,
   var wintype = document.documentElement.getAttribute("windowtype");
   var originCharset;
   if (wintype == "navigator:browser")
     originCharset = window.content.document.characterSet;
 
   // open link in new tab
   var referrerURI = aDocument ? aDocument.documentURIObject : null;
   var browser = top.document.getElementById("content");
+  
+  var inheritOptions = { };
+  // get current cookie container
+  browser.docShell.QueryInterface(Components.interfaces.nsICookieCollector);
+  inheritOptions.cookieContainer = browser.docShell.cookieContainer;
+  
   browser.loadOneTab(aURL, referrerURI, originCharset, aPostData,
-                     loadInBackground, aAllowThirdPartyFixup || false);
+                     loadInBackground, aAllowThirdPartyFixup || false, inheritOptions);
 }
 
 function openNewWindowWith(aURL, aDocument, aPostData, aAllowThirdPartyFixup)
 {
   if (aDocument)
     urlSecurityCheck(aURL, aDocument.nodePrincipal);
 
   // if and only if the current window is a browser window and it has a
@@ -570,12 +576,19 @@ function openNewWindowWith(aURL, aDocume
   // setting from the current document and use it to initialize the new browser
   // window...
   var charsetArg = null;
   var wintype = document.documentElement.getAttribute("windowtype");
   if (wintype == "navigator:browser")
     charsetArg = "charset=" + window.content.document.characterSet;
 
   var referrerURI = aDocument ? aDocument.documentURIObject : null;
+  var browser = top.document.getElementById("content");
+  
+  var inheritOptions = { };
+  // get current cookie container
+  browser.docShell.QueryInterface(Components.interfaces.nsICookieCollector);
+  inheritOptions.cookieContainer = browser.docShell.cookieContainer;
+  
   window.openDialog(getBrowserURL(), "_blank", "chrome,all,dialog=no",
                     aURL, charsetArg, referrerURI, aPostData,
-                    aAllowThirdPartyFixup);
+                    aAllowThirdPartyFixup, inheritOptions);
 }
Index: browser/components/preferences/cookies.js
===================================================================
RCS file: /cvsroot/mozilla/browser/components/preferences/cookies.js,v
retrieving revision 1.15
diff -p -U 8 -r1.15 cookies.js
--- browser/components/preferences/cookies.js	15 Sep 2006 21:28:47 -0000	1.15
+++ browser/components/preferences/cookies.js	14 May 2007 09:21:03 -0000
@@ -53,16 +53,20 @@ var gCookiesWindow = {
     var os = Components.classes["@mozilla.org/observer-service;1"]
                        .getService(Components.interfaces.nsIObserverService);
     os.addObserver(this, "cookie-changed", false);
     os.addObserver(this, "perm-changed", false);
     
     this._bundle = document.getElementById("bundlePreferences");
     this._tree = document.getElementById("cookiesList");
     
+    // check if a containerId was passed when opening this window
+    if (window.arguments && window.arguments[0])
+      this._cm = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService).getContainer(window.arguments[0]).QueryInterface(Components.interfaces.nsICookieManager);
+    
     this._loadCookies();
     this._tree.treeBoxObject.view = this._view;
     this.sort("rawHost");
     if (this._view.rowCount > 0) 
       this._tree.view.selection.select(0);
       
     document.getElementById("filter").focus();
   },
Index: browser/components/sessionstore/src/nsSessionStore.js
===================================================================
RCS file: /cvsroot/mozilla/browser/components/sessionstore/src/nsSessionStore.js,v
retrieving revision 1.60
diff -p -U 8 -r1.60 nsSessionStore.js
--- browser/components/sessionstore/src/nsSessionStore.js	12 Feb 2007 03:07:54 -0000	1.60
+++ browser/components/sessionstore/src/nsSessionStore.js	14 May 2007 09:21:09 -0000
@@ -15,16 +15,17 @@
  *
  * The Initial Developer of the Original Code is
  * Simon Bünzli <zeniko@gmail.com>
  * Portions created by the Initial Developer are Copyright (C) 2006
  * the Initial Developer. All Rights Reserved.
  *
  * Contributor(s):
  *   Dietrich Ayala <autonome@gmail.com>
+ *   Loune Lam <lpgcritter at nasquan dot com>
  *
  * Alternatively, the contents of this file may be used under the terms of
  * either the GNU General Public License Version 2 or later (the "GPL"), or
  * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
  * in which case the provisions of the GPL or the LGPL are applicable instead
  * of those above. If you wish to allow use of your version of this file only
  * under the terms of either the GPL or the LGPL, and not to allow others to
  * use your version of this file under the terms of the MPL, indicate your
@@ -793,16 +794,18 @@ SessionStoreService.prototype = {
       }
       tabData.zoom = browser.markupDocumentViewer.textZoom;
       
       var disallow = CAPABILITIES.filter(function(aCapability) {
         return !browser.docShell["allow" + aCapability];
       });
       tabData.disallow = disallow.join(",");
       
+      tabData.cookieContainer = browser.docShell.QueryInterface(Ci.nsICookieCollector).cookieContainer.containerId;
+      
       var _this = this;
       var xulattr = Array.filter(tabbrowser.mTabs[i].attributes, function(aAttr) {
         return (_this.xulAttributes.indexOf(aAttr.name) > -1);
       }).map(function(aAttr) {
         return aAttr.name + "=" + encodeURI(aAttr.value);
       });
       tabData.xultab = xulattr.join(" ");
       
@@ -985,84 +988,108 @@ SessionStoreService.prototype = {
   },
 
   /**
    * store all hosts for a URL
    * @param aWindow
    *        Window reference
    */
   _updateCookieHosts: function sss_updateCookieHosts(aWindow) {
-    var hosts = this._windows[aWindow.__SSi]._hosts = {};
+    var hosts = this._windows[aWindow.__SSi]._containerHosts = {};
+    var currentContainer;
     
     // get all possible subdomain levels for a given URL
     var _this = this;
     function extractHosts(aEntry) {
       if (/^https?:\/\/(?:[^@\/\s]+@)?([\w.-]+)/.test(aEntry.url) &&
-        !hosts[RegExp.$1] && _this._checkPrivacyLevel(_this._getURIFromString(aEntry.url).schemeIs("https"))) {
+        !hosts[currentContainer][RegExp.$1] && _this._checkPrivacyLevel(_this._getURIFromString(aEntry.url).schemeIs("https"))) {
         var host = RegExp.$1;
         var ix;
         for (ix = host.indexOf(".") + 1; ix; ix = host.indexOf(".", ix) + 1) {
-          hosts[host.substr(ix)] = true;
+          hosts[currentContainer][host.substr(ix)] = true;
         }
-        hosts[host] = true;
+        hosts[currentContainer][host] = true;
       }
       if (aEntry.children) {
         aEntry.children.forEach(extractHosts);
       }
     }
     
-    this._windows[aWindow.__SSi].tabs.forEach(function(aTabData) { aTabData.entries.forEach(extractHosts); });
+    this._windows[aWindow.__SSi].tabs.forEach(function(aTabData) {
+      currentContainer = aTabData.cookieContainer;
+      if (!hosts[currentContainer])
+        hosts[currentContainer] = {};
+      aTabData.entries.forEach(extractHosts);
+    });
   },
 
   /**
    * Serialize cookie data
    * @param aWindows
    *        array of Window references
    */
   _updateCookies: function sss_updateCookies(aWindows) {
-    var cookiesEnum = Cc["@mozilla.org/cookiemanager;1"].
-                      getService(Ci.nsICookieManager).enumerator;
+    var cookieSvc = Cc["@mozilla.org/cookieService;1"].getService(Ci.nsICookieService);
     // collect the cookies per window
     for (var i = 0; i < aWindows.length; i++) {
-      aWindows[i].cookies = { count: 0 };
+      aWindows[i].cookieContainers = { };
     }
     
-    var _this = this;
-    while (cookiesEnum.hasMoreElements()) {
-      var cookie = cookiesEnum.getNext().QueryInterface(Ci.nsICookie2);
-      if (cookie.isSession && cookie.host) {
-        var url = "", value = "";
-        aWindows.forEach(function(aWindow) {
-          if (aWindow._hosts && aWindow._hosts[cookie.rawHost]) {
-            // make sure to construct URL and value only once per cookie
-            if (!url) {
-              var url = "http" + (cookie.isSecure ? "s" : "") + "://" + cookie.host + (cookie.path || "").replace(/^(?!\/)/, "/");
-              if (_this._checkPrivacyLevel(cookie.isSecure)) {
-                value = (cookie.name || "name") + "=" + (cookie.value || "") + ";";
-                value += cookie.isDomain ? "domain=" + cookie.rawHost + ";" : "";
-                value += cookie.path ? "path=" + cookie.path + ";" : "";
-                value += cookie.isSecure ? "secure;" : "";
-              }
-            }
-            if (value) {
-              // in order to not unnecessarily bloat the session file,
-              // all window cookies are saved into one JS object
-              var cookies = aWindow.cookies;
-              cookies["domain" + ++cookies.count] = url;
-              cookies["value" + cookies.count] = value;
-            }
-          }
-        });
+    var _this = this;
+    var containers = [];
+    // for each window, retrieve the associated container
+    aWindows.forEach(function(aWindow) {
+      for (var cookieContainerId in aWindow._containerHosts) {
+	    var container = cookieSvc.getContainer(cookieContainerId);
+	    if (containers.indexOf(container) == -1)
+          containers.push(container);
+      }
+    });
+    
+    containers.forEach(function(aContainer) {
+      var containerId = aContainer.containerId;
+      dump("CCCCCCCCCCC PROCESSING "+containerId+"\n");
+      var cookiesEnum = aContainer.QueryInterface(Ci.nsICookieManager).enumerator;
+      while (cookiesEnum.hasMoreElements()) {
+        var cookie = cookiesEnum.getNext().QueryInterface(Ci.nsICookie2);
+        if (cookie.isSession && cookie.host) {
+          var url = "", value = "";
+          aWindows.forEach(function(aWindow) {
+            if (aWindow._containerHosts[containerId] && aWindow._containerHosts[containerId][cookie.rawHost]) {
+              // make sure to construct URL and value only once per cookie
+              if (!url) {
+                var url = "http" + (cookie.isSecure ? "s" : "") + "://" + cookie.host + (cookie.path || "").replace(/^(?!\/)/, "/");
+                if (_this._checkPrivacyLevel(cookie.isSecure)) {
+                  value = (cookie.name || "name") + "=" + (cookie.value || "") + ";";
+                  value += cookie.isDomain ? "domain=" + cookie.rawHost + ";" : "";
+                  value += cookie.path ? "path=" + cookie.path + ";" : "";
+                  value += cookie.isSecure ? "secure;" : "";
+                  value += cookie.httpOnly ? "HttpOnly;" : "";
+                }
+              }
+              if (value) {
+                // in order to not unnecessarily bloat the session file,
+                // all window cookies are saved into one JS object
+                var cookies = aWindow.cookieContainers;
+                if (!cookies[containerId])
+                  cookies[containerId] = { count: 0 };
+                cookies[containerId]["domain" + ++cookies[containerId].count] = url;
+                cookies[containerId]["value" + cookies[containerId].count] = value;
+              }
+              dump("CCCCCCCCCCC ADD "+cookie.host+" "+cookie.name+"\n");
+            }
+          });
+        }
       }
-    }
+    });
     
     // don't include empty cookie sections
     for (i = 0; i < aWindows.length; i++) {
-      if (aWindows[i].cookies.count == 0) {
-        delete aWindows[i].cookies;
+      if (aWindows[i].cookieContainers.count == 0) {
+        delete aWindows[i].cookieContainers;
       }
     }
   },
 
   /**
    * Store window dimensions, visibility, sidebar
    * @param aWindow
    *        Window reference
@@ -1209,18 +1236,18 @@ SessionStoreService.prototype = {
     // when overwriting tabs, remove all superflous ones
     for (t = openTabCount - 1; t >= newTabCount; t--) {
       tabbrowser.removeTab(tabbrowser.mTabs[t]);
     }
     
     if (aOverwriteTabs) {
       this.restoreWindowFeatures(aWindow, winData, root.opener || null);
     }
-    if (winData.cookies) {
-      this.restoreCookies(winData.cookies);
+    if (winData.cookieContainers) {
+      this.restoreCookies(winData.cookieContainers);
     }
     if (winData.extData) {
       if (!this._windows[aWindow.__SSi].extData) {
         this._windows[aWindow.__SSi].extData = {}
       }
       for (var key in winData.extData) {
         this._windows[aWindow.__SSi].extData[key] = winData.extData[key];
       }
@@ -1339,16 +1366,21 @@ SessionStoreService.prototype = {
     if (tabData.xultab) {
       tabData.xultab.split(" ").forEach(function(aAttr) {
         if (/^([^\s=]+)=(.*)/.test(aAttr)) {
           tab.setAttribute(RegExp.$1, decodeURI(RegExp.$2));
         }
       });
     }
     
+    if (tabData.cookieContainer) {
+      var cookieSvc = Cc["@mozilla.org/cookieService;1"].getService(Ci.nsICookieService);
+      browser.docShell.QueryInterface(Ci.nsICookieCollector).cookieContainer = cookieSvc.getContainer(tabData.cookieContainer);
+    }
+    
     // notify the tabbrowser that the tab chrome has been restored
     var event = aWindow.document.createEvent("Events");
     event.initEvent("SSTabRestoring", true, false);
     tab.dispatchEvent(event);
     
     var activeIndex = (tabData.index || tabData.entries.length) - 1;
     try {
       browser.webNavigation.gotoIndex(activeIndex);
@@ -1561,21 +1593,25 @@ SessionStoreService.prototype = {
    *        Array of cookie data
    */
   restoreCookies: function sss_restoreCookies(aCookies) {
     var cookieService = Cc["@mozilla.org/cookieService;1"].
                         getService(Ci.nsICookieService);
     var ioService = Cc["@mozilla.org/network/io-service;1"].
                     getService(Ci.nsIIOService);
     
-    for (var i = 1; i <= aCookies.count; i++) {
-      try {
-        cookieService.setCookieString(ioService.newURI(aCookies["domain" + i], null, null), null, aCookies["value" + i] + "expires=0;", null);
+    for (let [cookieContainerId, cookies] in aCookies) {
+      var cookieContainer = cookieService.getContainer(cookieContainerId);
+      for (var i = 1; i <= cookies.count; i++) {
+        try {
+          cookieService.setCookieString(cookieContainer, ioService.newURI(cookies["domain" + i], null, null),
+                                        null, cookies["value" + i] + "expires=0;", null);
+        }
+        catch (ex) { debug(ex); } // don't let a single cookie stop recovering (might happen if a user tried to edit the session file)
       }
-      catch (ex) { debug(ex); } // don't let a single cookie stop recovering (might happen if a user tried to edit the session file)
     }
   },
 
   /**
    * Restart incomplete downloads
    * @param aWindow
    *        Window reference
    */
Index: content/base/public/nsIDocument.h
===================================================================
RCS file: /cvsroot/mozilla/content/base/public/nsIDocument.h,v
retrieving revision 3.264
diff -p -U 8 -r3.264 nsIDocument.h
--- content/base/public/nsIDocument.h	10 May 2007 20:21:12 -0000	3.264
+++ content/base/public/nsIDocument.h	14 May 2007 09:21:13 -0000
@@ -113,16 +113,17 @@ public:
 #ifdef MOZILLA_INTERNAL_API
   nsIDocument()
     : nsINode(nsnull),
       mCharacterSet(NS_LITERAL_CSTRING("ISO-8859-1")),
       mBindingManager(nsnull),
       mNodeInfoManager(nsnull),
       mCompatMode(eCompatibility_FullStandards),
       mIsInitialDocumentInWindow(PR_FALSE),
+      mDocumentContainer(nsnull),
       mPartID(0)
   {
     mParentPtrBits |= PARENT_BIT_INDOCUMENT;
   }
 #endif
   
   /**
    * Let the document know that we're starting to load data into it.
Index: content/base/src/nsContentSink.cpp
===================================================================
RCS file: /cvsroot/mozilla/content/base/src/nsContentSink.cpp,v
retrieving revision 1.75
diff -p -U 8 -r1.75 nsContentSink.cpp
--- content/base/src/nsContentSink.cpp	14 May 2007 03:52:49 -0000	1.75
+++ content/base/src/nsContentSink.cpp	14 May 2007 09:21:15 -0000
@@ -81,16 +81,18 @@
 #include "nsTimer.h"
 #include "nsIAppShell.h"
 #include "nsWidgetsCID.h"
 #include "nsIDOMNSDocument.h"
 #include "nsIRequest.h"
 #include "nsNodeUtils.h"
 #include "nsIDOMNode.h"
 #include "nsThreadUtils.h"
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
 
 PRLogModuleInfo* gContentSinkLogModuleInfo;
 
 class nsScriptLoaderObserverProxy : public nsIScriptLoaderObserver
 {
 public:
   nsScriptLoaderObserverProxy(nsIScriptLoaderObserver* aInner)
     : mInner(do_GetWeakReference(aInner))
@@ -427,17 +429,24 @@ nsContentSink::ProcessHeaderData(nsIAtom
       window->GetPrompter(getter_AddRefs(prompt));
     }
 
     nsCOMPtr<nsIChannel> channel;
     if (mParser) {
       mParser->GetChannel(getter_AddRefs(channel));
     }
 
-    rv = cookieServ->SetCookieString(codebaseURI,
+    // find the cookie container
+    nsCOMPtr<nsISupports> docShell = mDocument->GetContainer();
+    nsCOMPtr<nsICookieCollector> cookieCollector = do_QueryInterface(docShell);
+    nsCOMPtr<nsICookieContainer> cookieContainer;
+    cookieCollector->GetCookieContainer(getter_AddRefs(cookieContainer));
+
+    rv = cookieServ->SetCookieString(cookieContainer,
+                                     codebaseURI,
                                      prompt,
                                      NS_ConvertUTF16toUTF8(aValue).get(),
                                      channel);
     if (NS_FAILED(rv)) {
       return rv;
     }
   }
   else if (aHeader == nsGkAtoms::link) {
Index: content/base/src/nsDocument.cpp
===================================================================
RCS file: /cvsroot/mozilla/content/base/src/nsDocument.cpp,v
retrieving revision 3.732
diff -p -U 8 -r3.732 nsDocument.cpp
--- content/base/src/nsDocument.cpp	12 May 2007 15:36:28 -0000	3.732
+++ content/base/src/nsDocument.cpp	14 May 2007 09:21:21 -0000
@@ -133,16 +133,19 @@ static NS_DEFINE_CID(kDOMEventGroupCID, 
 
 #include "nsIScriptContext.h"
 #include "nsBindingManager.h"
 #include "nsIDOMHTMLDocument.h"
 #include "nsIDOMHTMLFormElement.h"
 #include "nsIRequest.h"
 #include "nsILink.h"
 
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
+
 #include "nsICharsetAlias.h"
 #include "nsIParser.h"
 #include "nsIContentSink.h"
 
 #include "nsDateTimeFormatCID.h"
 #include "nsIDateTimeFormat.h"
 #include "nsEventDispatcher.h"
 #include "nsMutationEvent.h"
@@ -901,16 +904,17 @@ NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION(
   NS_INTERFACE_MAP_ENTRY(nsIDOMNode)
   NS_INTERFACE_MAP_ENTRY(nsPIDOMEventTarget)
   NS_INTERFACE_MAP_ENTRY(nsIDOM3Node)
   NS_INTERFACE_MAP_ENTRY(nsIDOM3Document)
   NS_INTERFACE_MAP_ENTRY(nsISupportsWeakReference)
   NS_INTERFACE_MAP_ENTRY(nsIRadioGroupContainer)
   NS_INTERFACE_MAP_ENTRY(nsINode)
   NS_INTERFACE_MAP_ENTRY(nsIMutationObserver)
+  NS_INTERFACE_MAP_ENTRY(nsIInterfaceRequestor)
   NS_INTERFACE_MAP_ENTRY_AMBIGUOUS(nsISupports, nsIDocument)
   if (aIID.Equals(NS_GET_IID(nsIDOMXPathEvaluator)) ||
       aIID.Equals(NS_GET_IID(nsIXPathEvaluatorInternal))) {
     if (!mXPathEvaluatorTearoff) {
       nsresult rv;
       mXPathEvaluatorTearoff =
         do_CreateInstance(NS_XPATH_EVALUATOR_CONTRACTID,
                           NS_STATIC_CAST(nsIDocument *, this), &rv);
@@ -5870,8 +5874,38 @@ nsDocument::GetScriptTypeID(PRUint32 *aS
 }
 
 NS_IMETHODIMP
 nsDocument::SetScriptTypeID(PRUint32 aScriptType)
 {
     NS_ERROR("Can't change default script type for a document");
     return NS_ERROR_NOT_IMPLEMENTED;
 }
+
+NS_IMETHODIMP
+nsDocument::GetInterface(const nsIID & aIID, void **aSink)
+{
+    NS_ENSURE_ARG_POINTER(aSink);
+    *aSink = nsnull;
+    nsresult rv;
+
+    if (aIID.Equals(NS_GET_IID(nsICookieCollector))) {
+        *aSink = mDocumentContainer;
+    }
+    else if (aIID.Equals(NS_GET_IID(nsICookieContainer))) {
+        nsCOMPtr<nsICookieCollector> cookieCollector = do_QueryReferent(mDocumentContainer);
+        nsCOMPtr<nsICookieContainer> cookieContainer = nsnull;
+        if (cookieCollector) {
+            cookieCollector->GetCookieContainer(getter_AddRefs(cookieContainer));
+        }
+        if (!cookieContainer)
+            return NS_NOINTERFACE;
+        *aSink = cookieContainer;
+    }
+
+    if (*aSink) {
+        NS_IF_ADDREF(((nsISupports *) * aSink));
+        return NS_OK;
+    }
+    else
+        return QueryInterface(aIID, aSink);
+}
+
Index: content/base/src/nsDocument.h
===================================================================
RCS file: /cvsroot/mozilla/content/base/src/nsDocument.h,v
retrieving revision 3.340
diff -p -U 8 -r3.340 nsDocument.h
--- content/base/src/nsDocument.h	12 May 2007 15:36:28 -0000	3.340
+++ content/base/src/nsDocument.h	14 May 2007 09:21:24 -0000
@@ -87,16 +87,17 @@
 #include "nsIScriptEventManager.h"
 #include "nsILayoutHistoryState.h"
 #include "nsIRequest.h"
 #include "nsILoadGroup.h"
 #include "nsTObserverArray.h"
 #include "nsStubMutationObserver.h"
 #include "nsIChannel.h"
 #include "nsCycleCollectionParticipant.h"
+#include "nsIInterfaceRequestor.h"
 
 // Put these here so all document impls get them automatically
 #include "nsHTMLStyleSheet.h"
 #include "nsIHTMLCSSStyleSheet.h"
 
 #include "nsStyleSet.h"
 #include "nsXMLEventsManager.h"
 #include "pldhash.h"
@@ -288,17 +289,18 @@ class nsDocument : public nsIDocument,
                    public nsIDOMDocumentXBL,
                    public nsIDOM3Document,
                    public nsSupportsWeakReference,
                    public nsIDOMEventReceiver,
                    public nsIDOM3EventTarget,
                    public nsIDOMNSEventTarget,
                    public nsIScriptObjectPrincipal,
                    public nsIRadioGroupContainer,
-                   public nsStubMutationObserver
+                   public nsStubMutationObserver,
+                   public nsIInterfaceRequestor
 {
 public:
   NS_DECL_CYCLE_COLLECTING_ISUPPORTS
 
   virtual void Reset(nsIChannel *aChannel, nsILoadGroup *aLoadGroup);
   virtual void ResetToURI(nsIURI *aURI, nsILoadGroup *aLoadGroup,
                           nsIPrincipal* aPrincipal);
 
@@ -615,16 +617,19 @@ public:
   NS_DECL_NSIDOMEVENTTARGET
 
   // nsIDOM3EventTarget
   NS_DECL_NSIDOM3EVENTTARGET
 
   // nsIDOMNSEventTarget
   NS_DECL_NSIDOMNSEVENTTARGET
 
+  // nsIInterfaceRequestor
+  NS_DECL_NSIINTERFACEREQUESTOR
+
   // nsIScriptObjectPrincipal
   virtual nsIPrincipal* GetPrincipal();
 
   virtual nsresult Init();
   
   virtual nsresult AddXMLEventsContent(nsIContent * aXMLEventsElement);
 
   virtual nsresult CreateElem(nsIAtom *aName, nsIAtom *aPrefix,
Index: content/base/src/nsObjectLoadingContent.cpp
===================================================================
RCS file: /cvsroot/mozilla/content/base/src/nsObjectLoadingContent.cpp,v
retrieving revision 1.40
diff -p -U 8 -r1.40 nsObjectLoadingContent.cpp
--- content/base/src/nsObjectLoadingContent.cpp	1 May 2007 22:24:20 -0000	1.40
+++ content/base/src/nsObjectLoadingContent.cpp	14 May 2007 09:21:27 -0000
@@ -55,16 +55,18 @@
 #include "nsIPresShell.h"
 #include "nsIScriptGlobalObject.h"
 #include "nsIScriptSecurityManager.h"
 #include "nsIStreamConverterService.h"
 #include "nsIURILoader.h"
 #include "nsIURL.h"
 #include "nsIWebNavigation.h"
 #include "nsIWebNavigationInfo.h"
+#include "nsICookieCollector.h"
+#include "nsICookieContainer.h"
 
 #include "nsPluginError.h"
 
 // Util headers
 #include "prlog.h"
 
 #include "nsAutoPtr.h"
 #include "nsCURILoader.h"
@@ -970,16 +972,23 @@ nsObjectLoadingContent::LoadObject(nsIUR
   NS_ENSURE_SUCCESS(rv, rv);
 
   // Referrer
   nsCOMPtr<nsIHttpChannel> httpChan(do_QueryInterface(chan));
   if (httpChan) {
     httpChan->SetReferrer(doc->GetDocumentURI());
   }
 
+  // set the cookie container of the channel to that of the doc's
+  nsCOMPtr<nsICookieCollector> cookieCollector(do_QueryInterface(chan));
+  if (cookieCollector) {
+    nsCOMPtr<nsICookieContainer> container(do_GetInterface(doc));
+    cookieCollector->SetCookieContainer(container);
+  }
+
   // MIME Type hint
   if (!aTypeHint.IsEmpty()) {
     chan->SetContentType(aTypeHint);
   }
 
   // AsyncOpen can fail if a file does not exist.
   // Show fallback content in that case.
   rv = chan->AsyncOpen(this, nsnull);
